#include <dos.h>
#include <graph.h>

void mscuron(void);
void mscuroff(void);
void msposxy(int, int);

int msbtns(void);
int msrow(void);
int mscol(void);

int msdet(void);

void msposxy(int row, int column)         /* Send mouse to (row,column)    */
  { union REGS inregs, outregs;           /* Specify TEXT row,column       */
    struct videoconfig vc;
    int rowmul, colmul;

    _getvideoconfig(&vc);
    switch (vc.mode)
      { case 0: case 1: case 2: case 3:   /* Munge row number from text    */
        case 7:    { rowmul=8; break; }   /* row to mouse's weirdo row no. */
        default:   { rowmul=1; break; }
      }
    switch (vc.mode)                      /* Likewise for the column ...   */
      { case 0: case 1: { colmul=16; break; }
        case 2: case 3: case 7: { colmul=8; break; }
        case 4: case 5: case 0xd: case 0x13: { colmul=2; break; }
        case 6: case 0xe: case 0xf: case 0x10: case 0x11: case 0x12: { colmul=1; break; }
      }
    inregs.x.ax=4;
    inregs.x.cx=colmul*column;
    inregs.x.dx=rowmul*row;
    int86(0x33,&inregs,&outregs);
  }

int msbtns(void)                          /* Get button status             */
  { union REGS inregs, outregs;
    inregs.x.ax=3;                        /* You'll have to check your     */
    int86(0x33,&inregs,&outregs);         /* interrupt list to work out    */
    return outregs.x.bx;                  /* what the return values mean!  */
  }

int msrow(void)                           /* Get mouse row                 */
  { union REGS inregs, outregs;
    struct videoconfig vc;
    int rowdiv;

    _getvideoconfig(&vc);
    switch (vc.mode)                      
      { case 0: case 1: case 2: case 3:
        case 7:  { rowdiv=8; break; }     /* Munge result to return        */
        default: { rowdiv=1; break; }     /* text row, not weirdo row      */
      }
    inregs.x.ax=3;
    int86(0x33,&inregs,&outregs);
    return outregs.x.dx/rowdiv;
  }

int mscol(void)                           /* Get mouse column              */
  { union REGS inregs, outregs;
    struct videoconfig vc;
    int coldiv;

    _getvideoconfig(&vc);
    switch (vc.mode)                      /* Munge again ...               */
      { case 0: case 1: { coldiv=16; break; }
        case 2: case 3: case 7: { coldiv=8; break; }
        case 4: case 5: case 0xd: case 0x13: { coldiv=2; break; }
        case 6: case 0xe: case 0xf: case 0x10: case 0x11: case 0x12: { coldiv=1; break; }
      }
    inregs.x.ax=3;
    int86(0x33,&inregs,&outregs);
    return outregs.x.cx/coldiv;
  }

void mscuron(void)                        /* Turn mouse cursor on          */
  { union REGS inregs, outregs;
    inregs.x.ax=0x0a;                     /* We make it a full block using */
    inregs.x.bx=0;                        /* character 0xDB                */
    inregs.x.cx=0xff00;
    inregs.x.dx=0xdb;
    int86(0x33,&inregs,&outregs);
    inregs.x.ax=1;
    int86(0x33,&inregs,&outregs);
  }

void mscuroff(void)                       /* Turn mouse cursor off         */
  { union REGS inregs, outregs;
    inregs.x.ax=2;
    int86(0x33,&inregs,&outregs);
  }

int msdet(void)                           /* Detect presence of mouse      */
  { union REGS inregs, outregs;

    inregs.x.ax=0;
    int86(0x33,&inregs,&outregs);
    return (outregs.x.ax==0xffff)?1:0;    /* 1 if mouse detected, 0 if not */
  }
